// FILE: land.h
// Written by: Grant Macklem (Grant.Macklem@colorado.edu)
// Last modified: May 1, 2002

#include <GL/glut.h>

#ifndef LAND_H
#define LAND_H

// Constants
extern const GLint GON_SIZE;          	// Polygon size
extern const GLint FIELD_SIZE;      	// Square landscape, power of two
extern const GLint LIMIT;              // Number of squares created
extern const GLdouble HEIGHT_MAX;    	// Limiting height for random landscape
extern const GLdouble EPSILON;			// Epsilon for thresholding
// FIELD_SIZE / GON_SIZE must be an integer


// Prototypes
void generate_landscape(GLdouble left, GLdouble right, GLdouble top,
	GLdouble bottom, GLdouble top_left_height, GLdouble top_right_height,
   GLdouble bottom_left_height, GLdouble bottom_right_height);
void fix_matrix();
void display();
void display_lagrange();
void get_rgb(GLdouble x, GLdouble& red, GLdouble& green, GLdouble& blue);
void reshape(int w, int h);
void init();
GLfloat clamp(GLfloat& angle);
void special(int key, int x, int y);
void keyboard(unsigned char key, int x, int y);
void write_out();
void smooth_curve();
void smooth_lagrange();
void lagrange_rows(int i, int j);
void lagrange_cols(int i, int j);
void smooth_patch();
void compute_points(int i, int j);
double patch_eval(double p[4][4], double u, double v);


// Global Variables
extern GLdouble** grid;
extern GLdouble** patchgrid;
//GLdouble grid[LIMIT+1][LIMIT+1];
extern GLdouble* points;
//GLint base[LIMIT + 1];
extern GLdouble** interp;
extern GLint* base;
extern GLint used;
extern GLfloat xrot, yrot, zrot;
extern unsigned int seed;

#endif  // LAND_H